$(document).ready(function () {
	if (typeof graph_data !== 'undefined') {
		$.each(graph_data[0].graph, function (time, graph) {
			var graph_title = '';
			if (time == 'daily') 
				graph_title = 'Daily (5 Minutes Average)';
			else if (time == 'weekly')
				graph_title = 'Weekly (30 Minutes Average)';
			else if (time == 'monthly')
				graph_title = 'Monthly (2 Hours Average)';
			var title = 'Inbound [Current: 0 ] [Average: 0] [Maximum: 0]';
			var titleSC = 'Outbond [Current: 0] [Average: 0] [Maximum: 0]';
			var titleNF = '95 Percentile: 0 mbit';
			var dataProvider = [];
			if (graph != null) {
				var info = graph['data'][0];
				title = 'Inbound [Current: ' + info['curVA'] + info['unit'] + '] [Average: ' + info['aveVA'] + info['unit'] + '] [Maximum: ' + info['maxVA'] + info['unit'] + ']';
				titleSC = 'Outbond [Current: ' + info['curVASC'] + info['unit'] + '] [Average: ' + info['aveVASC'] + info['unit'] + '] [Maximum: ' + info['maxVASC'] + info['unit'] + ']';
				titleNF = '95 Percentile: ' + info['ninetyfifth'] + ' mbit';
				dataProvider = graph['data'];
			}
			var chart = AmCharts.makeChart('chart-' + time, {
				'dataProvider': dataProvider,
				'type': 'serial',
				'marginRight': 80,
				'mouseWheelZoomEnabled': false,
				'graphs': [
					{
						'valueField': 'bps',
						'type': 'line',
						'lineColor': '#00cf00',
						'fillColors': '#00cf00',
						'fillAlphas': 0.7,
						'balloonText': '[[value]]',
						'legendColor': '#00cf00',

						'title': title
					},
					{
						'valueField': 'bps_to',
						'type': 'line',
						'lineColor': '#072f97',
						'legendColor': '#4aa3df',
						'title': titleSC
					},
					{
						'valueField': 'ninetyfifth',
						'type': 'line',
						'lineColor': '#e10707',
						'legendColor': '#e10707',
						'title': titleNF
					}
				],
				'categoryField': 'hours',
				'categoryAxis': {
					'gridCount': 10,
					'parseDates': true,
					'minPeriod': 'mm',
					'dateFormats': [
						{period: 'fff', format: 'JJ:NN:SS'},
						{period: 'ss', format: 'JJ:NN:SS'},
						{period: 'mm', format: 'JJ:NN'},
						{period: 'hh', format: 'JJ:NN'},
						{period: 'DD', format: 'MMM DD'},
						{period: 'WW', format: 'MMM DD'},
						{period: 'MM', format: 'DD MM YYYY'},
						{period: 'YYYY', format: 'YYYY'}
					],
					'title': graph_title,
					'titleBold': false
				},
				'valueAxes': [
					{'title': 'bits per second', 'titleBold': false}
				],
				'chartScrollbar': {
					'autoGridCount': true,
					'graph': 'g1',
					'scrollbarHeight': 40
				},
				'export': {
					'enabled': true,
				},
				'legend': {
					'userGraphSettings': true
				}
			});
		});
	}
});