<?php

namespace WHMCS\Module\Addon\PowerActionModule\Client;

/**
 * Sample Client Area Dispatch Handler
 */
class ClientDispatcher 
{
    /**
     * Dispatch request.
     *
     * @param string $action
     * @param array $parameters
     *
     * @return array
     */
    public function dispatch($action, $parameters)
    {
        if (!$action) {
            // Default to index if no action specified
            $action = 'index';
        }
        $controller = new Controller();
        
        // Verify requested action is valid and callable
        if (is_callable(array($controller, $action))) {
            return $controller->$action($parameters);
        } else {
            header("HTTP/1.0 404 Not Found");
            exit();
        }
    }
}