<?php

namespace WHMCS\Module\Addon\PowerActionModule\Client;

/**
 * Test Client Area Controller
 */
class Controller 
{
    protected $limit = 10;

    /**
     * Index action.
     *
     * @param array $vars Module configuration parameters
     *
     * @return array
     */
    public function index($vars)
    {
        $offset = 0;
        $limit = $this->limit;
        $page = 1;
        if (isset($_GET['page']) && !is_nan($_GET['page'])) {
            $page = $_GET['page'];
            $offset = $this->limit * ($page - 1);
            $limit = $this->limit * $page;
        }
        $product_status = [Product::STATUS_ACTIVE, Product::STATUS_MAINTENANCE, Product::STATUS_TOBETAKENDOWN, Product::STATUS_TOBESUSPENDED, Product::STATUS_SUSPENDED];
        $postfields = [
            'action' => 'product_getproductlists',
            'product_type' => 'Prebuilt Server',
            'customer_id' => $vars['Customer ID'],
            'limit_num' => $limit,
            'limit_start' => $offset
        ];
        $client_products = $this->callOmega($postfields);
        return array(
            'pagetitle' => 'Power Action',
            'breadcrumb' => array(
                'index.php?m=power_action_module' => 'Power Action',
            ),
            'templatefile' => 'server_list',
            'requirelogin' => true,
            'forcessl' => true, // Deprecated as of Version 7.0. Requests will always use SSL if available.
            'vars' => array(
                'module_link' => $vars['modulelink'], // eg. addonmodules.php?module=power_action_module
                'client_products' => $client_products
            ),
        );
    }

    private function callOmega($vars, $postfields)
    {
        $api_url = 'https://api-admin-beta.wowrack.com/admin-api/';
        $api_key = $vars['API Key'];
        $api_username = $vars['Email Address'];
        $customer_id = $vars['Customer ID'];

        if ($api_logged) {
            $this->log();
        } else {
            $otherfield = array(
                'app_key' => $api_key,
                'username'=> $api_username,
                'version' => 2
            );
            $postfields = array_merge($otherfield, $postfields);
            // echo '<pre>';print_r($postfields);exit();
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $api_url);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_TIMEOUT, 100);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == "on") {
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            } else {
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            }

            $api = curl_exec($ch);
            $err = curl_error($ch);
            curl_close($ch);

            if ($err == "" || $api != false) {
                return $this->_output($api,$output);
            } else {
                echo $err;
                die();
            }
        }
    }
}