<?php

if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

session_start();

function callOmega($whmcs_params, $postfields)
{
    require('config.php');

    $api_key = $whmcs_params['configoption1'];
    $customer_id = $whmcs_params['configoption2'];
    $customer_email = $whmcs_params['configoption3'];
    $customer_ip = $whmcs_params['configoption4'];

    $otherfield = [
        'api_key' => $api_key,
        'cust_id' => $customer_id,
        'cust_email'=> $customer_email,
        'cust_ip' => $customer_ip
    ];
    $postfields = array_merge($otherfield, $postfields);
    
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $api_url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 100);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postfields));

    if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == "on") {
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    } else {
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    }

    $api = curl_exec($ch);
    $err = curl_error($ch);

    curl_close($ch);

    if ($err == "" || $api != false) {
        return (object) [
            'result' => TRUE,
            'data' => $api != 'null' ? json_decode($api) : null
        ];
    } else {
        return (object) [
            'result' => FALSE,
            'message' => $err
        ];
    }
}

function ssreseller_MetaData()
{
    return array(
        'DisplayName' => 'SS Reseller',
    );
}

function ssreseller_ConfigOptions()
{
    return [
        'api_key' => [
            'FriendlyName' => 'API Key',
            'Type' => 'text',
            'Default' => '',
            'Description' => 'Your API key'
        ],
        'customer_id' => [
            'FriendlyName' => 'SS Customer ID',
            'Type' => 'text',
            'Length' => 10,
            'Description' => 'Your Serverstadium customer ID'
        ],
        'email' => [
            'FriendlyName' => 'SS Customer Email',
            'Type' => 'text',
            'Length' => 10,
            'Description' => 'Your Serverstadium email'
        ],
        'customer_ip' => [
            'FriendlyName' => 'IP Address',
            'Type' => 'text',
            'length' => 15,
            'Description' => 'Your IP Address'
        ]
    ];
}

function ssreseller_AdminCustomButtonArray()
{
    $buttons = [];
    $buttons['Power On'] = 'powerOnAdmin';
    $buttons['Power Off'] = 'powerOffAdmin';
    $buttons['Reboot'] = 'powerRebootAdmin';
    return $buttons;
}

function ssreseller_ClientAreaCustomButtonArray(array $params)
{
    $postfields = [
        'action' => 'productstatus',
        'prod_id' => $params['customfields']['SS Product ID']
    ];
    $omega_result = callOmega($params, $postfields);
    if (isset($omega_result->result) && $omega_result->result) {
        $product_status = $omega_result->data;
        if (strtolower($product_status) == 'active') {
            $buttons['Power On'] = 'powerOn';
            $buttons['Power Off'] = 'powerOff';
            $buttons['Reboot'] = 'powerReboot';
            $buttons['Reinstall OS'] = 'reinstallOs';
        }
    }
    return $buttons;
}

function ssreseller_powerOn(array $params)
{
    try {
        if ($_REQUEST['modaction'] == 'powerOn') {
            $postfields = [
                'action' => 'poweraction',
                'power_action' => 'on',
                'prod_id' => $params['customfields']['SS Product ID']
            ];
            $omega_result = callOmega($params, $postfields);
            if (isset($omega_result->result) && $omega_result->result && $omega_result->data === true) {
                $message = "Succesffuly turn on server.";
                $_SESSION['success'] = $message;
                header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
                exit();
            } else {
                $message = $omega_result->data;
                $_SESSION['error'] = $message;
                header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
                exit();
            }
        }
        return array(
            'templatefile' => 'confirmation',
            'breadcrumb' => array(
                'javascript:;' => 'Power On',
            ),
            'vars' => array(
                'question' => 'Are you sure want to turn on this server?',
                'params' => $params,
                'modaction' => 'powerOn'
            ),
        );
    } catch (Exception $e) {
        logModuleCall(
            'ssreseller',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
}

function ssreseller_powerOnAdmin(array $params)
{
    try {
        $postfields = [
            'action' => 'productstatus',
            'prod_id' => $params['customfields']['SS Product ID']
        ];
        $omega_result = callOmega($params, $postfields);
        if (isset($omega_result->result) && $omega_result->result) {
            $product_status = $omega_result->data;
            if (strtolower($product_status) != 'active') {
                return "Product status is not active.";
            }
        } else {
            return $omega_result->data;
        }
        $postfields = [
            'action' => 'poweraction',
            'power_action' => 'on',
            'prod_id' => $params['customfields']['SS Product ID']
        ];
        $omega_result = callOmega($params, $postfields);
        if (isset($omega_result->result) && $omega_result->result && $omega_result->data === true) {
            return "success";
        } else {
            return $omega_result->data;
        }
    } catch (Exception $e) {
        logModuleCall(
            'ssreseller',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
}

function ssreseller_powerOff(array $params)
{
    try {
        if ($_REQUEST['modaction'] == 'powerOff') {
            $postfields = [
                'action' => 'poweraction',
                'power_action' => 'off',
                'prod_id' => $params['customfields']['SS Product ID']
            ];
            $omega_result = callOmega($params, $postfields);
            if (isset($omega_result->result) && $omega_result->result && $omega_result->data === true) {
                $message = "Succesffuly turn off server.";
                $_SESSION['success'] = $message;
                header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
                exit();
            } else {
                $message = $omega_result->data;
                $_SESSION['error'] = $message;
                header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
                exit();
            }
        }
        return array(
            'templatefile' => 'confirmation',
            'breadcrumb' => array(
                'javascript:;' => 'Power On',
            ),
            'vars' => array(
                'question' => 'Are you sure want to turn off this server?',
                'params' => $params,
                'modaction' => 'powerOff'
            ),
        );
    } catch (Exception $e) {
        logModuleCall(
            'ssreseller',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
}

function ssreseller_powerOffAdmin(array $params)
{
    try {
        $postfields = [
            'action' => 'productstatus',
            'prod_id' => $params['customfields']['SS Product ID']
        ];
        $omega_result = callOmega($params, $postfields);
        if (isset($omega_result->result) && $omega_result->result) {
            $product_status = $omega_result->data;
            if (strtolower($product_status) != 'active') {
                return "Product status is not active.";
            }
        } else {
            return $omega_result->data;
        }
        $postfields = [
            'action' => 'poweraction',
            'power_action' => 'off',
            'prod_id' => $params['customfields']['SS Product ID']
        ];
        $omega_result = callOmega($params, $postfields);
        if (isset($omega_result->result) && $omega_result->result && $omega_result->data === true) {
            return "success";
        } else {
            return $omega_result->data;
        }
    } catch (Exception $e) {
        logModuleCall(
            'ssreseller',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
}

function ssreseller_powerReboot(array $params)
{
    try {
        if ($_REQUEST['modaction'] == 'powerReboot') {
            $postfields = [
                'action' => 'poweraction',
                'power_action' => 'reset',
                'prod_id' => $params['customfields']['SS Product ID']
            ];
            $omega_result = callOmega($params, $postfields);
            if (isset($omega_result->result) && $omega_result->result && $omega_result->data === true) {
                $message = "Succesffuly reboot server.";
                $_SESSION['success'] = $message;
                header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
                exit();
            } else {
                $message = $omega_result->data;
                $_SESSION['error'] = $message;
                header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
                exit();
            }
        }
        return array(
            'templatefile' => 'confirmation',
            'breadcrumb' => array(
                'javascript:;' => 'Reboot Server',
            ),
            'vars' => array(
                'question' => 'Are you sure want to reboot this server?',
                'params' => $params,
                'modaction' => 'powerReboot'
            ),
        );
    } catch (Exception $e) {
        logModuleCall(
            'ssreseller',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
}

function ssreseller_powerRebootAdmin(array $params)
{
    try {
        $postfields = [
            'action' => 'productstatus',
            'prod_id' => $params['customfields']['SS Product ID']
        ];
        $omega_result = callOmega($params, $postfields);
        if (isset($omega_result->result) && $omega_result->result) {
            $product_status = $omega_result->data;
            if (strtolower($product_status) != 'active') {
                return "Product status is not active.";
            }
        } else {
            return $omega_result->data;
        }
        $postfields = [
            'action' => 'poweraction',
            'power_action' => 'reset',
            'prod_id' => $params['customfields']['SS Product ID']
        ];
        $omega_result = callOmega($params, $postfields);
        if (isset($omega_result->result) && $omega_result->result && $omega_result->data === true) {
            return "success";
        } else {
            return $omega_result->data;
        }
    } catch (Exception $e) {
        logModuleCall(
            'ssreseller',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
}

function ssreseller_reinstallOs(array $params)
{
    try {
        if ($_REQUEST['modaction'] == 'reinstallOs') {
            if (empty($_POST['server_profile_id'])) {
                $message = "Please choose an OS.";
                $_SESSION['error'] = $message;
                header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid'] . '&modop=custom&a=reinstallOs');
                exit();
            }
            $postfields = [
                'action' => 'reinstallos',
                'prod_id' => $params['customfields']['SS Product ID'],
                'profile_id' => $_POST['server_profile_id']
            ];
            $omega_result = callOmega($params, $postfields);
            if (isset($omega_result->result) && $omega_result->result && $omega_result->data === true) {
                $message = "Succesffuly reinstall OS.";
                $_SESSION['success'] = $message;
                header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
                exit();
            } else {
                $message = $omega_result->data;
                $_SESSION['error'] = $message;
                header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
                exit();
            }
        }
        $postfields = [
            'action' => 'availableos',
            'prod_id' => $params['customfields']['SS Product ID']
        ];
        $omega_result = callOmega($params, $postfields);
        if (isset($omega_result->result) && $omega_result->result) {
            return [
                'templatefile' => 'reinstallationForm',
                'breadcrumb' => [
                    'Reinstall OS'
                ],
                'vars' => [
                    'options' => $omega_result->data,
                    'modaction' => 'reinstallOs'
                ],
            ];
        } else if (!is_array($omega_result->data)) {
            $message = $omega_result->data;
            $_SESSION['error'] = $message;
            header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
            exit();
        } else {
            $message = $omega_result->message;
            $_SESSION['error'] = $message;
            header('Location: clientarea.php?action=productdetails&id=' . $params['serviceid']);
            exit();
        }
    } catch (Exception $e) {
        logModuleCall(
            'ssreseller',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
}

function ssreseller_AdminServicesTabFields(array $params)
{
    require('config.php');
    
    try {
        $username_info = "";
        $password_info = "";
        $ip_address = "";
        $postfields = [
            'action' => 'productinfo',
            'prod_id' => $params['customfields']['SS Product ID']
        ];
        $omega_result = callOmega($params, $postfields);
        if (isset($omega_result->result) && $omega_result->result) {
            if (!empty($omega_result->data)) {
                $ip_address = implode(', ', $omega_result->data->ip_address);
                $username_info = $omega_result->data->username;
                $password_info = $omega_result->data->password;
            }
        }
        
        $graph_data = [
            [
                'graph' => [
                    'daily' => null,
                    'monthly' => null,
                    'weekly' => null
                ]
            ]
        ];
        $postfields = [
            'action' => 'bandwidth',
            'prod_id' => $params['customfields']['SS Product ID']
        ];
        $omega_result = callOmega($params, $postfields);
        if (isset($omega_result->result) && $omega_result->result) {
            if (!empty($omega_result->data)) {
                $daily = formatBandwidthData($omega_result->data, 'daily_all');
                if (isset($daily)) {
                    $weekly = formatBandwidthData($omega_result->data, 'weekly_all');
                    $monthly = formatBandwidthData($omega_result->data, 'monthly_all');
                    $graph_data = [
                        [
                            'graph' => [
                                'daily' => ['data' => $daily, 'title' => 'Daily (5 Minutes Average)'],
                                'weekly' => ['data' => $weekly, 'title' => 'Weekly (30 Minutes Average)'],
                                'monthly' => ['data' => $monthly, 'title' => 'monthly (2 Hours Average)']
                            ]
                        ]
                    ];
                } else {
                    $graph_data = [['graph' => $daily]];
                }
            }
        }
        
        $graph = '<div class="bandwidth-container">
    <div id="chart-daily" style="width:100%; height:300px;" class="bw-graph" data-title="Daily (5 Minutes Average)"></div>
    <div id="chart-weekly" style="width:100%; height:300px;" class="bw-graph" data-title="Monthly (2 Hours Average)"></div>
    <div id="chart-monthly" style="width:100%; height:300px;" class="bw-graph" data-title="Weekly (30 Minutes Average)"></div>
</div>';
        $scriptPath = [
            $path_to_module . '/includes/amchart/amcharts.js',
            $path_to_module . '/includes/amchart/serial.js',
            $path_to_module . '/includes/amchart/themes/patterns.js',
            $path_to_module . '/includes/amchart/plugins/export/export.js',
            $path_to_module . '/includes/bandwidth.js'
        ];
        foreach ($scriptPath as $path) {
            $graph .= '<script defer type="text/javascript" src="' . $path . '"></script>';
        }
        $graph .= '<script type="text/javascript">
    var graph_data = JSON.parse(' . "'" . json_encode($graph_data) . "'" . ');
</script>';

        /* OS Reinstallation */
        $options = '<option value="" disabled selected>Choose OS</option>';
        $postfields = [
            'action' => 'availableos',
            'prod_id' => $params['customfields']['SS Product ID']
        ];
        $omega_result = callOmega($params, $postfields);
        if (isset($omega_result->result) && $omega_result->result) {
            $list_os = $omega_result->data;
            foreach ($list_os as $key => $os_option) {
                $options .= '<option value="' . $os_option->details->nocps_profile_id . '">' . $os_option->display_name . '</option>';
            }
        }

        return array(
            'Server IP Address' => $ip_address,
            'Server Username' => $username_info,
            'Server Password' => $password_info,
            'Bandwidth' => $graph
        );
    } catch (Exception $e) {
        logModuleCall(
            'ssreseller',
            __FUNCTION__,
            $params,
            $e->getMessage(),
            $e->getTraceAsString()
        );
        return $e->getMessage();
    }
    return 'success';
}

function ssreseller_ClientArea(array $params)
{
    /* Username, password, ip_address info*/
    $username_info = "";
    $password_info = "";
    $ip_address = "";
    $postfields = [
        'action' => 'productinfo',
        'prod_id' => $params['customfields']['SS Product ID']
    ];
    $omega_result = callOmega($params, $postfields);
    if (isset($omega_result->result) && $omega_result->result) {
        if (!empty($omega_result->data)) {
            $ip_address = implode(', ', $omega_result->data->ip_address);
            $username_info = $omega_result->data->username;
            $password_info = $omega_result->data->password;
        }
    }
    $server_info = '<hr><h4>Server Information</h4><p>Username: ' . $username_info . '</p><p>Password: ' . $password_info . '</p><p>IP Address: ' . $ip_address . '</p>';

    /* Bandwidth Information */
    $graph_data = [
        [
            'graph' => [
                'daily' => null,
                'monthly' => null,
                'weekly' => null
            ]
        ]
    ];
    $postfields = [
        'action' => 'bandwidth',
        'prod_id' => $params['customfields']['SS Product ID']
    ];
    $omega_result = callOmega($params, $postfields);
    if (isset($omega_result->result) && $omega_result->result) {
        if (!empty($omega_result->data)) {
            $daily = formatBandwidthData($omega_result->data, 'daily_all');
            if (isset($daily)) {
                $weekly = formatBandwidthData($omega_result->data, 'weekly_all');
                $monthly = formatBandwidthData($omega_result->data, 'monthly_all');
                $graph_data = [
                    [
                        'graph' => [
                            'daily' => ['data' => $daily, 'title' => 'Daily (5 Minutes Average)'],
                            'weekly' => ['data' => $weekly, 'title' => 'Weekly (30 Minutes Average)'],
                            'monthly' => ['data' => $monthly, 'title' => 'monthly (2 Hours Average)']
                        ]
                    ]
                ];
            } else {
                $graph_data = [['graph' => $daily]];
            }
        }
    }
    
    $graph = '<hr><h4>Bandwidth Information</h4><div class="row"><div class="col-md-12 bandwidth-container">
    <div id="chart-daily" style="width:100%; height:300px;" class="bw-graph" data-title="Daily (5 Minutes Average)"></div>
    <div id="chart-weekly" style="width:100%; height:300px;" class="bw-graph" data-title="Monthly (2 Hours Average)"></div>
    <div id="chart-monthly" style="width:100%; height:300px;" class="bw-graph" data-title="Weekly (30 Minutes Average)"></div>
    </div></div>';
        $graph .= '<script type="text/javascript">
        if (typeof graph_data === "undefined")
    var graph_data = JSON.parse(' . "'" . json_encode($graph_data) . "'" . ');
    </script>';

    /* Power Management */
    $pow_management = '<hr><h4>Power Management</h4><div class="row"><div class="col-md-12">
        <form method="get" action="clientarea.php" style="display: inline;">
            <input type="hidden" name="action" value="productdetails">
            <input type="hidden" name="id" value="' . $params['serviceid'] . '">
            <input type="hidden" name="modop" value="custom">
            <input type="hidden" name="a" value="powerOn">
            <button class="btn btn-success" type="submit">Turn On Server</button>
        </form>
        <form method="get" action="clientarea.php" style="display: inline;">
            <input type="hidden" name="action" value="productdetails">
            <input type="hidden" name="id" value="' . $params['serviceid'] . '">
            <input type="hidden" name="modop" value="custom">
            <input type="hidden" name="a" value="powerOff">
            <button class="btn btn-danger" type="submit">Turn Off Server</button>
        </form>
        <form method="get" action="clientarea.php" style="display: inline;">
            <input type="hidden" name="action" value="productdetails">
            <input type="hidden" name="id" value="' . $params['serviceid'] . '">
            <input type="hidden" name="modop" value="custom">
            <input type="hidden" name="a" value="powerReboot">
            <button class="btn btn-warning" type="submit">Reboot Server</button>
        </form>
    </div></div>';

    $show_additional_info = false;
    $postfields = [
        'action' => 'productstatus',
        'prod_id' => $params['customfields']['SS Product ID']
    ];
    $omega_result = callOmega($params, $postfields);
    if (isset($omega_result->result) && $omega_result->result) {
        $product_status = $omega_result->data;
        if (strtolower($product_status) == 'active') {
            $show_additional_info = true;
        }
    }

    /* OS Reinstallation */
    $options = '<option value="" disabled selected>Choose OS</option>';
    $postfields = [
        'action' => 'availableos',
        'prod_id' => $params['customfields']['SS Product ID']
    ];
    $omega_result = callOmega($params, $postfields);
    if (isset($omega_result->result) && $omega_result->result) {
        $list_os = $omega_result->data;
        foreach ($list_os as $key => $os_option) {
            $options .= '<option value="' . $os_option->product_option_id . '">' . $os_option->display_name . '</option>';
        }
    }
    $os_reinstallation = '<hr><h4>Reinstall OS</h4><div class="row"><div class="col-md-6 col-md-offset-3">
        <form method="get" action="clientarea.php">
            <input type="hidden" name="action" value="productdetails">
            <input type="hidden" name="id" value="' . $params['serviceid'] . '">
            <input type="hidden" name="modop" value="custom">
            <input type="hidden" name="a" value="reinstallOs">
            <button class="btn btn-warning" type="submit">Reinstall OS</button>
        </form>
    </div></div>';

    $flash_message = "";
    if (!empty($_SESSION['error'])) {
        $flash_message .= '<div class="alert alert-danger">' . $_SESSION['error'] . '</div>';
    } else if (!empty($_SESSION['success'])) {
        $flash_message .= '<div class="alert alert-success">' . $_SESSION['success'] . '</div>';
    }
    if (!empty($_SESSION['error'])) unset($_SESSION['error']);
    if (!empty($_SESSION['success'])) unset($_SESSION['success']);

    return $flash_message . ($show_additional_info === true ? $pow_management . $os_reinstallation : '') . $server_info . $graph;
}

function formatBandwidthData($cacti_data_arr, $range)
{
    $cacti_data_arr = json_decode(json_encode($cacti_data_arr), true);
    if (empty($cacti_data_arr) || !is_array($cacti_data_arr))
        return null;
    $arr_nf = [
        $cacti_data_arr['ninetyfifth'] => $cacti_data_arr['ninetyfifth']
    ];
    $nf95 = $cacti_data_arr['ninetyfifth'];
    $cacti_data_arr = [
        'data' => $cacti_data_arr
    ];
    if ($range === 'monthly_all') {
        $cacti_data = $cacti_data_arr['data'][0]['graphDataMonthly'];
        $max_all = max(array_merge($cacti_data['traffic_in'], $cacti_data['traffic_out'], $arr_nf)) * 8;
        $min_all = min(array_merge($cacti_data['traffic_in'], $cacti_data['traffic_out'], $arr_nf)) * 8;
    } else {
        if ($range == 'daily_all')
            $cacti_data = $cacti_data_arr['data'][0]['graphDataDaily'];
        else if ($range == 'weekly_all')
            $cacti_data = $cacti_data_arr['data'][0]['graphDataWeekly'];
        $max_all = max(array_merge($cacti_data['traffic_in'], $cacti_data['traffic_out'])) * 8;
        $min_all = min(array_merge($cacti_data['traffic_in'], $cacti_data['traffic_out'])) * 8;
    }
    $sum_all = array_sum(array_merge($cacti_data['traffic_in'], $cacti_data['traffic_out'])) * 8;
    $count_all = count(array_merge($cacti_data['traffic_in'], $cacti_data['traffic_out']));
    $ave_all = $sum_all / $count_all;
    $i = 0;
    foreach ($cacti_data['traffic_in'] AS $kTI => $vTI) {
        $time = getdate($kTI);

        if ($max_all > (1000 * 1000)) {
            $trns_in = ($vTI * 8) / (1000 * 1000);
            $trns_in_unit = ' M';
        } elseif ($max_all > 1000) {
            $trns_in = ($vTI * 8) / 1000;
            $trns_in_unit = ' K';
        } else {
            $trns_in = $vTI * 8;
            $trns_in_unit = '';
        }

        $traf_in[$i]['hours'] = date('Y m d H:i:s', $kTI);
        $traf_in[$i]['bps'] = $trns_in;
        $traf_in[0]['unit'] = $trns_in_unit;
        $i++;
    }
    $j = 0;
    foreach ($cacti_data['traffic_out'] AS $kTO => $vTO) {
        $time = getdate($kTO);
        if ($max_all > 1000 * 1000) {
            $trns_out = ($vTO * 8) / (1000 * 1000);
            $trns_out_unit = ' M';
        } elseif ($max_all > 1000) {
            $trns_out = ($vTO * 8) / 1000;
            $trns_out_unit = ' K';
        } else {
            $trns_out = $vTO * 8;
            $trns_out_unit = '';
        }
        $traf_out[$j]['hours_to'] = date('Y m d H:i:s', $kTO);
        $traf_out[$j]['bps_to'] = $trns_out;
        $traf_out[$j]['hours'] = $traf_in[$j]['hours'];
        $traf_out[$j]['bps'] = $traf_in[$j]['bps'];
        $traf_out[0]['unit'] = $traf_in[0]['unit'];
        $traf_out[0]['unit_to'] = $trns_out_unit;

        $j++;
    }

    if ($max_all > (1000 * 1000))
        $nf = $nf95 / (1000 * 1000);
    elseif ($max_all > 1000)
        $nf = $nf95 / 1000;
    else
        $nf = $nf95;

    $new95th = calculateFiveNine($cacti_data['traffic_in'],$cacti_data['traffic_out']);
    $k = 0;
    foreach ($cacti_data['traffic_in'] AS $vTO) {
        $traf_out[$k]['ninetyfifth'] = (float) $new95th;
        $k++;
    }
    $nf_comp = (float)round($nf, 2);
    $arrTraf = $traf_out;

    foreach ($arrTraf AS $kRD => $vRD) {
        if ($vRD['bps'] !== 0)
            $bps[$kRD] = (float)$vRD['bps'];
        else
            $bps[$kRD] = 0;

        if ($vRD['bps_to'] !== 0)
            $bps_to[$kRD] = (float)$vRD['bps_to'];
        else
            $bps_to[$kRD] = 0;
    }

    $va_step_one = (max($bps) > max($bps_to)) ? max($bps) : max($bps_to);
    $va = ($va_step_one > $nf_comp) ? $va_step_one : $nf_comp;
    $maxVA = (int)ceil($va);

    $va_sc = (min($bps) < min($bps_to)) ? min($bps) : min($bps_to);
    $minVA = (int)ceil($va_sc);

    $av_va = array_sum($bps) / count($bps);
    $av_va_sc = array_sum($bps_to) / count($bps_to);

    $max_va = max($bps);
    $max_va_sc = max($bps_to);

    $keyCur = count($bps) - 2;
    $keyCurTO = count($bps_to) - 2;

    $cur_va = $bps[$keyCur];
    $cur_va_sc = $bps_to[$keyCurTO];

    $legendData = array(
        'maxAll' => $maxVA,
        'minAll' => $minVA,
        'maxVA' => round($max_va, 2, PHP_ROUND_HALF_DOWN),
        'maxVASC' => round($max_va_sc, 2, PHP_ROUND_HALF_DOWN),
        'curVA' => round($cur_va, 2, PHP_ROUND_HALF_DOWN),
        'curVASC' => round($cur_va_sc, 2, PHP_ROUND_HALF_DOWN),
        'aveVA' => round($av_va, 2, PHP_ROUND_HALF_DOWN),
        'aveVASC' => round($av_va_sc, 2, PHP_ROUND_HALF_DOWN)
    );

    $arrTraf[0]['maxAll'] = $legendData['maxAll'];
    $arrTraf[0]['minAll'] = $legendData['minAll'];
    $arrTraf[0]['maxVA'] = $legendData['maxVA'];
    $arrTraf[0]['maxVASC'] = $legendData['maxVASC'];
    $arrTraf[0]['curVA'] = $legendData['curVA'];
    $arrTraf[0]['curVASC'] = $legendData['curVASC'];
    $arrTraf[0]['aveVA'] = $legendData['aveVA'];
    $arrTraf[0]['aveVASC'] = $legendData['aveVASC'];

    $tbytes = $cacti_data['totalbytes'];
    if ($tbytes > 1000 * 1000) {
        $totalbytes = $cacti_data['totalbytes'] / (1000 * 1000);
        $tbytesformat = 'MB';
    } elseif ($tbytes > 1000) {
        $totalbytes = $cacti_data['totalbytes'] / 1000;
        $tbytesformat = 'KB';
    } else {
        $totalbytes = $cacti_data['totalbytes'];
        $tbytesformat = 'Bytes';
    }
    $arrTraf[0]['totalbytes'] = $totalbytes;
    $arrTraf[0]['tbytesformat'] = $tbytesformat;

    return $arrTraf;
}

function calculateFiveNine($in, $out){
    $all_sort = arrangeTraffic(array_merge($in,$out));
    $d = round((5/100) * (count($in)));
    $g = array_slice($all_sort[0], 0, (count($all_sort[0]) - $d));
    return round((max($g) / (1000 * 1000)), 2);
}

function arrangeTraffic($values) {
    foreach ($values as $k => $v) {
        if(!is_nan($v)) {
            $trafficinbits[] = $v * 8;
            $trafficinbytes[] = $v;
            sort($trafficinbits);
            sort($trafficinbytes);
            $bothtraffic = [$trafficinbits,$trafficinbytes];
        }
    }
    return $bothtraffic;
}